//KOGADO BND/IDX Archive
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

unsigned char	fileheader[4] = { 0x00, 0x00, 0x00, 0x00 };

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	char				tmp[12];
	unsigned char		*buf;
	unsigned char		*filebuf;
	unsigned long		header_length = 0L;
	unsigned int		file_count = 0;
	unsigned long		file_ed = 0L;

	char				index_filename[12];
	char				header_filename[12];
	unsigned long		header_filest = 0L;
	unsigned long		header_fileed = 0L;
	unsigned long		header_filesize = 0L;

	unsigned long		nowsize = 0L;

	unsigned int		i;

	printf( "KOGADO BND/IDX Divider 060204 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: APD2DIV <filename_dat>\n" );
		return;
	}

	//IDX file
	strcpy( index_filename, av[1] );
	memcpy( &index_filename[strlen( index_filename ) - 3], "IDX", 3 );

	in = fopen( index_filename, "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", index_filename );
		return;
	}
	printf( "index_filename: %s\n", index_filename );

	fseek( in, 0x0C, SEEK_SET );
	fread( tmp, 4, 1, in );
	if( memcmp( tmp, fileheader, 4 ))
	{
		printf( "error: not BND/IDX format.\n" );
		goto end2;
	}

	//filesize
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );

	//Header size
	header_length = file_ed;

	//Read header
	buf = ( unsigned char * )calloc( 1, header_length );
	fseek( in, 0, SEEK_SET );
	fread( buf, header_length, 1, in );

	fclose( in );

	printf( "header_length: %lu(%04lX)\n", header_length, header_length );

	//file_count
	file_count = header_length / 0x18;

	printf( "file_count: %d\n", file_count );

	//.BND file
	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}
	printf( "data_filename: %s\n", av[1] );

	//filesize
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );

	printf( "file_size: %lu bytes\n", file_ed );
	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		memcpy( header_filename, &buf[i*0x18], 13 );

		header_filest = *( unsigned long *)( buf + ( i * 0x18 ) + 0x14 );
		if( i == file_count - 1 ) header_fileed = file_ed;
		else header_fileed = *( unsigned long *)( buf + ( i * 0x18 ) + 0x2C );
		header_filesize = header_fileed - header_filest;

		printf( "%03d %-13s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		out = fopen( header_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		filebuf = ( unsigned char * )calloc( 1, 32768 );	//32k
		nowsize = header_filesize;
		fseek( in, header_filest, SEEK_SET );

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );
		printf( ".\n" );
		fclose( out );

		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );

end:;
	free( buf );
end2:;
	fclose( in );
	return;
}
